<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.efm.column;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.DataInput;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.DataOutput;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.File;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.IOException;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.math.BigInteger;<a name="line.40"></a>
<FONT color="green">041</FONT>    <a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.bitset.IBitSet;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.jbase.EntityMarshaller;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.jbase.VariableWidthTable;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.jbase.concurrent.ConcurrentTable;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.math.BigFraction;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.math.NumberOperations;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.math.ops.BigIntegerOperations;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.metabolic.FluxDistribution;<a name="line.49"></a>
<FONT color="green">050</FONT>    import ch.javasoft.metabolic.MetabolicNetwork;<a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.metabolic.efm.config.Arithmetic;<a name="line.51"></a>
<FONT color="green">052</FONT>    import ch.javasoft.metabolic.efm.memory.outcore.Cache;<a name="line.52"></a>
<FONT color="green">053</FONT>    import ch.javasoft.metabolic.efm.model.ColumnInspectorModifier;<a name="line.53"></a>
<FONT color="green">054</FONT>    import ch.javasoft.metabolic.efm.model.EfmModel;<a name="line.54"></a>
<FONT color="green">055</FONT>    import ch.javasoft.metabolic.efm.model.IterationStateModel;<a name="line.55"></a>
<FONT color="green">056</FONT>    import ch.javasoft.metabolic.efm.model.IterationStepModel;<a name="line.56"></a>
<FONT color="green">057</FONT>    import ch.javasoft.metabolic.efm.util.BitSetUtil;<a name="line.57"></a>
<FONT color="green">058</FONT>    import ch.javasoft.metabolic.impl.FractionNumberFluxDistribution;<a name="line.58"></a>
<FONT color="green">059</FONT>    import ch.javasoft.smx.iface.ReadableBigIntegerMatrix;<a name="line.59"></a>
<FONT color="green">060</FONT>    import ch.javasoft.smx.iface.ReadableBigIntegerRationalMatrix;<a name="line.60"></a>
<FONT color="green">061</FONT>    import ch.javasoft.smx.iface.ReadableMatrix;<a name="line.61"></a>
<FONT color="green">062</FONT>    import ch.javasoft.smx.impl.DefaultBigIntegerMatrix;<a name="line.62"></a>
<FONT color="green">063</FONT>    import ch.javasoft.smx.ops.Gauss;<a name="line.63"></a>
<FONT color="green">064</FONT>    import ch.javasoft.util.Arrays;<a name="line.64"></a>
<FONT color="green">065</FONT>    import ch.javasoft.util.ByteArray;<a name="line.65"></a>
<FONT color="green">066</FONT>    import ch.javasoft.util.numeric.BigIntegerUtil;<a name="line.66"></a>
<FONT color="green">067</FONT>    import ch.javasoft.util.numeric.Zero;<a name="line.67"></a>
<FONT color="green">068</FONT>    <a name="line.68"></a>
<FONT color="green">069</FONT>    /**<a name="line.69"></a>
<FONT color="green">070</FONT>     * A &lt;tt&gt;RawBigIntegerColumn&lt;/tt&gt; implements the numeric part of the column with<a name="line.70"></a>
<FONT color="green">071</FONT>     * {@link BigInteger large integer numbers}, but stores them encoded as raw<a name="line.71"></a>
<FONT color="green">072</FONT>     * bytes in a single byte array. <a name="line.72"></a>
<FONT color="green">073</FONT>     * &lt;p&gt;<a name="line.73"></a>
<FONT color="green">074</FONT>     * The first byte of a value in the array indicates the number of bytes for the<a name="line.74"></a>
<FONT color="green">075</FONT>     * next big integer. If it is zero, the value is zero. Otherwise, if the first <a name="line.75"></a>
<FONT color="green">076</FONT>     * bit is zero, the next 7 bits encode for the byte length directly. Otherwise, <a name="line.76"></a>
<FONT color="green">077</FONT>     * the first 4 bytes encode for the length, ignoring the negative sign bit in <a name="line.77"></a>
<FONT color="green">078</FONT>     * the resulting integer.    <a name="line.78"></a>
<FONT color="green">079</FONT>     */<a name="line.79"></a>
<FONT color="green">080</FONT>    public class RawBigIntegerColumn extends AbstractColumn {<a name="line.80"></a>
<FONT color="green">081</FONT>            <a name="line.81"></a>
<FONT color="green">082</FONT>            private int                             mBoolSize;<a name="line.82"></a>
<FONT color="green">083</FONT>            private int                             mNumericSize;<a name="line.83"></a>
<FONT color="green">084</FONT>            private final IBitSet   mBitSet;<a name="line.84"></a>
<FONT color="green">085</FONT>            private byte[]                  mNumericBytes;<a name="line.85"></a>
<FONT color="green">086</FONT>    <a name="line.86"></a>
<FONT color="green">087</FONT>            public RawBigIntegerColumn(int boolSize) {<a name="line.87"></a>
<FONT color="green">088</FONT>                    mBoolSize               = boolSize;<a name="line.88"></a>
<FONT color="green">089</FONT>                    mBitSet                 = BitSetUtil.factory().create(boolSize);<a name="line.89"></a>
<FONT color="green">090</FONT>                    mNumericBytes   = new byte[0];<a name="line.90"></a>
<FONT color="green">091</FONT>            }<a name="line.91"></a>
<FONT color="green">092</FONT>            protected RawBigIntegerColumn(int boolSize, int numericSize, IBitSet bitSet, byte[] numericBytes) {<a name="line.92"></a>
<FONT color="green">093</FONT>                    mBoolSize               = boolSize;<a name="line.93"></a>
<FONT color="green">094</FONT>                    mNumericSize    = numericSize;<a name="line.94"></a>
<FONT color="green">095</FONT>                    mBitSet                 = bitSet;<a name="line.95"></a>
<FONT color="green">096</FONT>                    mNumericBytes   = numericBytes;<a name="line.96"></a>
<FONT color="green">097</FONT>            }<a name="line.97"></a>
<FONT color="green">098</FONT>            <a name="line.98"></a>
<FONT color="green">099</FONT>            public IBitSet bitValues() {<a name="line.99"></a>
<FONT color="green">100</FONT>                    return mBitSet;<a name="line.100"></a>
<FONT color="green">101</FONT>            }<a name="line.101"></a>
<FONT color="green">102</FONT>            <a name="line.102"></a>
<FONT color="green">103</FONT>            public &lt;N extends Number&gt; N getNumeric(ColumnHome&lt;N, ?&gt; columnHome, int row) {<a name="line.103"></a>
<FONT color="green">104</FONT>                    return columnHome.castNumber(toBigInteger(mNumericBytes, row));<a name="line.104"></a>
<FONT color="green">105</FONT>            }<a name="line.105"></a>
<FONT color="green">106</FONT>        <a name="line.106"></a>
<FONT color="green">107</FONT>            private static BigInteger toBigInteger(byte[] bytes, int row) {<a name="line.107"></a>
<FONT color="green">108</FONT>                    final int offset = getOffset(bytes, row);<a name="line.108"></a>
<FONT color="green">109</FONT>                    final byte first = bytes[offset];<a name="line.109"></a>
<FONT color="green">110</FONT>                    if (first == 0) { <a name="line.110"></a>
<FONT color="green">111</FONT>                            return BigInteger.ZERO;<a name="line.111"></a>
<FONT color="green">112</FONT>                    }<a name="line.112"></a>
<FONT color="green">113</FONT>                    if (0 == (0x80 &amp; first)) {<a name="line.113"></a>
<FONT color="green">114</FONT>                            return new BigInteger(Arrays.copyOfRange(bytes, offset+1, offset+1+first));<a name="line.114"></a>
<FONT color="green">115</FONT>                    }<a name="line.115"></a>
<FONT color="green">116</FONT>                    final int len = 0x7fffffff &amp; ((first &lt;&lt; 24) | (bytes[offset+1] &lt;&lt; 16) | (bytes[offset+2] &lt;&lt; 8) | bytes[offset+3]); <a name="line.116"></a>
<FONT color="green">117</FONT>                    return new BigInteger(Arrays.copyOfRange(bytes, offset+4, offset+4+len));<a name="line.117"></a>
<FONT color="green">118</FONT>            }<a name="line.118"></a>
<FONT color="green">119</FONT>            private static int toSignum(byte[] bytes, int row) {<a name="line.119"></a>
<FONT color="green">120</FONT>                    final int offset = getOffset(bytes, row);<a name="line.120"></a>
<FONT color="green">121</FONT>                    final byte first = bytes[offset];<a name="line.121"></a>
<FONT color="green">122</FONT>                    final byte mostsig;<a name="line.122"></a>
<FONT color="green">123</FONT>                    if (first == 0) {<a name="line.123"></a>
<FONT color="green">124</FONT>                            return 0;<a name="line.124"></a>
<FONT color="green">125</FONT>                    }<a name="line.125"></a>
<FONT color="green">126</FONT>                    else if (0 == (0x80 &amp; first)) {<a name="line.126"></a>
<FONT color="green">127</FONT>                            mostsig = bytes[offset+1];<a name="line.127"></a>
<FONT color="green">128</FONT>                    }<a name="line.128"></a>
<FONT color="green">129</FONT>                    else {<a name="line.129"></a>
<FONT color="green">130</FONT>                            mostsig = bytes[offset+4];                      <a name="line.130"></a>
<FONT color="green">131</FONT>                    }<a name="line.131"></a>
<FONT color="green">132</FONT>                    return mostsig == 0 ? 0 : mostsig &lt; 0 ? -1 : 1;<a name="line.132"></a>
<FONT color="green">133</FONT>            }<a name="line.133"></a>
<FONT color="green">134</FONT>            private static int getOffset(byte[] bytes, int row) {<a name="line.134"></a>
<FONT color="green">135</FONT>                    int offset = 0;<a name="line.135"></a>
<FONT color="green">136</FONT>                    while (row &gt; 0) {<a name="line.136"></a>
<FONT color="green">137</FONT>                            final byte first = bytes[offset];<a name="line.137"></a>
<FONT color="green">138</FONT>                            if (first == 0) {<a name="line.138"></a>
<FONT color="green">139</FONT>                                    offset++;<a name="line.139"></a>
<FONT color="green">140</FONT>                            }<a name="line.140"></a>
<FONT color="green">141</FONT>                            else if (0 == (0x80 &amp; first)) {<a name="line.141"></a>
<FONT color="green">142</FONT>                                    offset++;<a name="line.142"></a>
<FONT color="green">143</FONT>                                    offset+=first;<a name="line.143"></a>
<FONT color="green">144</FONT>                            }<a name="line.144"></a>
<FONT color="green">145</FONT>                            else {<a name="line.145"></a>
<FONT color="green">146</FONT>                                    final int len = 0x7fffffff &amp; ((first &lt;&lt; 24) | (bytes[offset+1] &lt;&lt; 16) | (bytes[offset+2] &lt;&lt; 8) | bytes[offset+3]);<a name="line.146"></a>
<FONT color="green">147</FONT>                                    offset += len + 4;<a name="line.147"></a>
<FONT color="green">148</FONT>                            }<a name="line.148"></a>
<FONT color="green">149</FONT>                            row--;<a name="line.149"></a>
<FONT color="green">150</FONT>                    }<a name="line.150"></a>
<FONT color="green">151</FONT>                    return offset;<a name="line.151"></a>
<FONT color="green">152</FONT>            }<a name="line.152"></a>
<FONT color="green">153</FONT>            <a name="line.153"></a>
<FONT color="green">154</FONT>            private BigInteger[] toBigIntegers() {<a name="line.154"></a>
<FONT color="green">155</FONT>                    final BigInteger[] res = new BigInteger[mNumericSize];<a name="line.155"></a>
<FONT color="green">156</FONT>                    int offset = 0;<a name="line.156"></a>
<FONT color="green">157</FONT>                    for (int i = 0; i &lt; res.length; i++) {<a name="line.157"></a>
<FONT color="green">158</FONT>                            offset += toBigInteger(res, i, mNumericBytes, offset);<a name="line.158"></a>
<FONT color="green">159</FONT>                    }<a name="line.159"></a>
<FONT color="green">160</FONT>                    return res;<a name="line.160"></a>
<FONT color="green">161</FONT>            }<a name="line.161"></a>
<FONT color="green">162</FONT>            private static int toBigInteger(BigInteger[] result, int resultIndex, byte[] bytes, int offset) {<a name="line.162"></a>
<FONT color="green">163</FONT>                    final byte first = bytes[offset];<a name="line.163"></a>
<FONT color="green">164</FONT>                    if (first == 0) {<a name="line.164"></a>
<FONT color="green">165</FONT>                            result[resultIndex] = BigInteger.ZERO;<a name="line.165"></a>
<FONT color="green">166</FONT>                            return 1;<a name="line.166"></a>
<FONT color="green">167</FONT>                    }<a name="line.167"></a>
<FONT color="green">168</FONT>                    if (0 == (0x80 &amp; first)) {<a name="line.168"></a>
<FONT color="green">169</FONT>                            result[resultIndex] = new BigInteger(Arrays.copyOfRange(bytes, offset+1, offset+1+first));<a name="line.169"></a>
<FONT color="green">170</FONT>                            return 1+first;<a name="line.170"></a>
<FONT color="green">171</FONT>                    }<a name="line.171"></a>
<FONT color="green">172</FONT>                    final int len = 0x7fffffff &amp; ((first &lt;&lt; 24) | (bytes[offset+1] &lt;&lt; 16) | (bytes[offset+2] &lt;&lt; 8) | bytes[offset+3]); <a name="line.172"></a>
<FONT color="green">173</FONT>                    result[resultIndex] = new BigInteger(Arrays.copyOfRange(bytes, offset+4, offset+4+len));<a name="line.173"></a>
<FONT color="green">174</FONT>                    return 4+len;<a name="line.174"></a>
<FONT color="green">175</FONT>            }<a name="line.175"></a>
<FONT color="green">176</FONT>            private static byte[] fromBigIntegers(BigInteger[] values) {<a name="line.176"></a>
<FONT color="green">177</FONT>                    final ByteArray buf = new ByteArray();<a name="line.177"></a>
<FONT color="green">178</FONT>                    for (int i = 0; i &lt; values.length; i++) {<a name="line.178"></a>
<FONT color="green">179</FONT>                            if (values[i].signum() == 0) {<a name="line.179"></a>
<FONT color="green">180</FONT>                                    buf.add((byte)0);<a name="line.180"></a>
<FONT color="green">181</FONT>                            }<a name="line.181"></a>
<FONT color="green">182</FONT>                            else {<a name="line.182"></a>
<FONT color="green">183</FONT>                                    final byte[] bytes = values[i].toByteArray();<a name="line.183"></a>
<FONT color="green">184</FONT>                                    final int len = bytes.length;<a name="line.184"></a>
<FONT color="green">185</FONT>                                    if (len &lt;= 0x0000007f) {<a name="line.185"></a>
<FONT color="green">186</FONT>                                            buf.add((byte)len);<a name="line.186"></a>
<FONT color="green">187</FONT>                                    }<a name="line.187"></a>
<FONT color="green">188</FONT>                                    else {<a name="line.188"></a>
<FONT color="green">189</FONT>                                            buf.add((byte)(0x00000080 | (len &gt;&gt; 24)));<a name="line.189"></a>
<FONT color="green">190</FONT>                                            buf.add((byte)(len &gt;&gt; 16));<a name="line.190"></a>
<FONT color="green">191</FONT>                                            buf.add((byte)(len &gt;&gt; 8));<a name="line.191"></a>
<FONT color="green">192</FONT>                                            buf.add((byte)len);<a name="line.192"></a>
<FONT color="green">193</FONT>                                    }<a name="line.193"></a>
<FONT color="green">194</FONT>                                    for (int j = 0; j &lt; bytes.length; j++) {<a name="line.194"></a>
<FONT color="green">195</FONT>                                            buf.add(bytes[j]);<a name="line.195"></a>
<FONT color="green">196</FONT>                                    }<a name="line.196"></a>
<FONT color="green">197</FONT>                            }<a name="line.197"></a>
<FONT color="green">198</FONT>                    }<a name="line.198"></a>
<FONT color="green">199</FONT>                    return buf.toArray();<a name="line.199"></a>
<FONT color="green">200</FONT>            }<a name="line.200"></a>
<FONT color="green">201</FONT>            <a name="line.201"></a>
<FONT color="green">202</FONT>            public int booleanSize() {<a name="line.202"></a>
<FONT color="green">203</FONT>                    return mBoolSize;<a name="line.203"></a>
<FONT color="green">204</FONT>            }<a name="line.204"></a>
<FONT color="green">205</FONT>            public int numericSize() {<a name="line.205"></a>
<FONT color="green">206</FONT>                    return mNumericSize;<a name="line.206"></a>
<FONT color="green">207</FONT>            }<a name="line.207"></a>
<FONT color="green">208</FONT>            public int size() {<a name="line.208"></a>
<FONT color="green">209</FONT>                    return mBoolSize + mNumericSize;<a name="line.209"></a>
<FONT color="green">210</FONT>            }<a name="line.210"></a>
<FONT color="green">211</FONT>            <a name="line.211"></a>
<FONT color="green">212</FONT>            public int getNumericSignum(Zero zero, int row) {<a name="line.212"></a>
<FONT color="green">213</FONT>                    return toSignum(mNumericBytes, row);<a name="line.213"></a>
<FONT color="green">214</FONT>            }<a name="line.214"></a>
<FONT color="green">215</FONT>            public int getHyperplaneSign(EfmModel model, IterationStateModel iteration) {<a name="line.215"></a>
<FONT color="green">216</FONT>                    return getColumnInspectorModifier(model, BigInteger.class, BigInteger[].class).getHyperplaneSign(columnHome(), model, mBitSet, mBoolSize, toBigIntegers(), iteration);<a name="line.216"></a>
<FONT color="green">217</FONT>            }<a name="line.217"></a>
<FONT color="green">218</FONT>            public &lt;Col extends Column&gt; Col convert(ColumnHome&lt;?,Col&gt; columnHome, EfmModel model, IterationStepModel iteration, boolean clone) {<a name="line.218"></a>
<FONT color="green">219</FONT>                    final BigInteger[] bigInts = toBigIntegers();<a name="line.219"></a>
<FONT color="green">220</FONT>                    final ColumnInspectorModifier&lt;BigInteger, BigInteger[]&gt; modifier = getColumnInspectorModifier(model, BigInteger.class, BigInteger[].class);<a name="line.220"></a>
<FONT color="green">221</FONT>                    final IBitSet   newBin = modifier.convertBinary(columnHome(), model, mBitSet, mBoolSize, bigInts, iteration, clone);<a name="line.221"></a>
<FONT color="green">222</FONT>                    final BigInteger[]              newNum = modifier.convertNumeric(columnHome(), model, mBitSet, mBoolSize, bigInts, iteration, clone);<a name="line.222"></a>
<FONT color="green">223</FONT>    <a name="line.223"></a>
<FONT color="green">224</FONT>                    if (clone) {<a name="line.224"></a>
<FONT color="green">225</FONT>                            return columnHome.castColumn(new RawBigIntegerColumn(iteration.getNextState().getBooleanSize(), newNum.length, newBin, fromBigIntegers(newNum)));<a name="line.225"></a>
<FONT color="green">226</FONT>                    }<a name="line.226"></a>
<FONT color="green">227</FONT>                    else {<a name="line.227"></a>
<FONT color="green">228</FONT>                            mBoolSize = iteration.getNextState().getBooleanSize();<a name="line.228"></a>
<FONT color="green">229</FONT>                            if (mBitSet != newBin) {<a name="line.229"></a>
<FONT color="green">230</FONT>                                    mBitSet.clear();<a name="line.230"></a>
<FONT color="green">231</FONT>                                    mBitSet.or(newBin);<a name="line.231"></a>
<FONT color="green">232</FONT>                            }<a name="line.232"></a>
<FONT color="green">233</FONT>                            mNumericSize    = newNum.length;<a name="line.233"></a>
<FONT color="green">234</FONT>                            mNumericBytes   = fromBigIntegers(newNum);<a name="line.234"></a>
<FONT color="green">235</FONT>                            return columnHome.castColumn(this);<a name="line.235"></a>
<FONT color="green">236</FONT>                    }<a name="line.236"></a>
<FONT color="green">237</FONT>            }<a name="line.237"></a>
<FONT color="green">238</FONT>            public &lt;Col extends Column&gt; Col mergeWith(ColumnHome&lt;?,Col&gt; columnHome, EfmModel model, Col other, IterationStepModel iteration) {<a name="line.238"></a>
<FONT color="green">239</FONT>                    return columnHome.castColumn(mergeWith(model, (RawBigIntegerColumn)other, iteration));<a name="line.239"></a>
<FONT color="green">240</FONT>            }<a name="line.240"></a>
<FONT color="green">241</FONT>            public RawBigIntegerColumn mergeWith(EfmModel model, RawBigIntegerColumn other, IterationStepModel iteration) {<a name="line.241"></a>
<FONT color="green">242</FONT>                    final BigInteger[] myBigInts = toBigIntegers();<a name="line.242"></a>
<FONT color="green">243</FONT>                    final BigInteger[] otBigInts = other.toBigIntegers();<a name="line.243"></a>
<FONT color="green">244</FONT>    <a name="line.244"></a>
<FONT color="green">245</FONT>                    final ColumnInspectorModifier&lt;BigInteger, BigInteger[]&gt; modifier = getColumnInspectorModifier(model, BigInteger.class, BigInteger[].class);<a name="line.245"></a>
<FONT color="green">246</FONT>                    final IBitSet newBin = modifier.mergeBinary(columnHome(), model, mBitSet, mBoolSize, myBigInts, other.mBitSet, other.mBoolSize, otBigInts, iteration);<a name="line.246"></a>
<FONT color="green">247</FONT>                    final BigInteger[] newNum = modifier.mergeNumeric(columnHome(), model, mBitSet, mBoolSize, myBigInts, other.mBitSet, other.mBoolSize, otBigInts, iteration);<a name="line.247"></a>
<FONT color="green">248</FONT>                    return new RawBigIntegerColumn(iteration.getNextState().getBooleanSize(), newNum.length, newBin, fromBigIntegers(newNum));<a name="line.248"></a>
<FONT color="green">249</FONT>            }<a name="line.249"></a>
<FONT color="green">250</FONT>    <a name="line.250"></a>
<FONT color="green">251</FONT>            public void writeTo(DataOutput dataOut) throws IOException {<a name="line.251"></a>
<FONT color="green">252</FONT>                    columnHome().writeTo(this, dataOut);<a name="line.252"></a>
<FONT color="green">253</FONT>            }<a name="line.253"></a>
<FONT color="green">254</FONT>            <a name="line.254"></a>
<FONT color="green">255</FONT>            @Override<a name="line.255"></a>
<FONT color="green">256</FONT>            public RawBigIntegerColumn clone() {<a name="line.256"></a>
<FONT color="green">257</FONT>                    return new RawBigIntegerColumn(mBoolSize, mNumericSize, mBitSet.clone(), Arrays.copyOf(mNumericBytes, mNumericBytes.length));<a name="line.257"></a>
<FONT color="green">258</FONT>            }<a name="line.258"></a>
<FONT color="green">259</FONT>    <a name="line.259"></a>
<FONT color="green">260</FONT>            @Override<a name="line.260"></a>
<FONT color="green">261</FONT>            public boolean equals(Object obj) {<a name="line.261"></a>
<FONT color="green">262</FONT>                    if (obj == this) return true;<a name="line.262"></a>
<FONT color="green">263</FONT>                    if (obj instanceof RawBigIntegerColumn) {<a name="line.263"></a>
<FONT color="green">264</FONT>                            final RawBigIntegerColumn col = (RawBigIntegerColumn)obj;<a name="line.264"></a>
<FONT color="green">265</FONT>                            return<a name="line.265"></a>
<FONT color="green">266</FONT>                                    mBoolSize == col.mBoolSize &amp;&amp;<a name="line.266"></a>
<FONT color="green">267</FONT>                                    mBitSet.equals(col.mBitSet) &amp;&amp; <a name="line.267"></a>
<FONT color="green">268</FONT>                                    java.util.Arrays.equals(mNumericBytes, col.mNumericBytes);<a name="line.268"></a>
<FONT color="green">269</FONT>                    }<a name="line.269"></a>
<FONT color="green">270</FONT>                    return false;<a name="line.270"></a>
<FONT color="green">271</FONT>            }<a name="line.271"></a>
<FONT color="green">272</FONT>            <a name="line.272"></a>
<FONT color="green">273</FONT>            @Override<a name="line.273"></a>
<FONT color="green">274</FONT>            public String toString() {<a name="line.274"></a>
<FONT color="green">275</FONT>                    StringBuffer sb = new StringBuffer();<a name="line.275"></a>
<FONT color="green">276</FONT>                    sb.append('{');<a name="line.276"></a>
<FONT color="green">277</FONT>                    for (int ii = 0; ii &lt; mBoolSize; ii++) {<a name="line.277"></a>
<FONT color="green">278</FONT>                            sb.append(mBitSet.get(ii) ? '1' : '0');<a name="line.278"></a>
<FONT color="green">279</FONT>                    }<a name="line.279"></a>
<FONT color="green">280</FONT>                    final BigInteger[] bigInts = toBigIntegers();<a name="line.280"></a>
<FONT color="green">281</FONT>                    for (int ii = 0; ii &lt; bigInts.length; ii++) {<a name="line.281"></a>
<FONT color="green">282</FONT>                            if (mBoolSize &gt; 0 || ii &gt; 0) sb.append(", ");<a name="line.282"></a>
<FONT color="green">283</FONT>                            sb.append(bigInts[ii]);<a name="line.283"></a>
<FONT color="green">284</FONT>                    }<a name="line.284"></a>
<FONT color="green">285</FONT>                    sb.append('}');<a name="line.285"></a>
<FONT color="green">286</FONT>                    return sb.toString();<a name="line.286"></a>
<FONT color="green">287</FONT>            }<a name="line.287"></a>
<FONT color="green">288</FONT>        <a name="line.288"></a>
<FONT color="green">289</FONT>            public Home columnHome() {<a name="line.289"></a>
<FONT color="green">290</FONT>                    return HOME;<a name="line.290"></a>
<FONT color="green">291</FONT>            }<a name="line.291"></a>
<FONT color="green">292</FONT>            <a name="line.292"></a>
<FONT color="green">293</FONT>            public static abstract class Home<a name="line.293"></a>
<FONT color="green">294</FONT>                    extends         AbstractHome&lt;BigInteger, RawBigIntegerColumn&gt; <a name="line.294"></a>
<FONT color="green">295</FONT>                    implements      ColumnHome&lt;BigInteger, RawBigIntegerColumn&gt; {}<a name="line.295"></a>
<FONT color="green">296</FONT>            <a name="line.296"></a>
<FONT color="green">297</FONT>            public static final Home HOME = new Home() {<a name="line.297"></a>
<FONT color="green">298</FONT>                    public Arithmetic getArithmetic() {<a name="line.298"></a>
<FONT color="green">299</FONT>                            return Arithmetic.rawint;<a name="line.299"></a>
<FONT color="green">300</FONT>                    }<a name="line.300"></a>
<FONT color="green">301</FONT>                    public NumberOperations&lt;BigInteger&gt; getNumberOperations() {<a name="line.301"></a>
<FONT color="green">302</FONT>                            return BigIntegerOperations.instance();<a name="line.302"></a>
<FONT color="green">303</FONT>                    }<a name="line.303"></a>
<FONT color="green">304</FONT>                    public RawBigIntegerColumn newInstance(int booleanSize, int numericSize) {<a name="line.304"></a>
<FONT color="green">305</FONT>                throw new RuntimeException("not implemented");<a name="line.305"></a>
<FONT color="green">306</FONT>                            //return new FractionalColumn(booleanSize, numericSize);<a name="line.306"></a>
<FONT color="green">307</FONT>                    }<a name="line.307"></a>
<FONT color="green">308</FONT>                    public RawBigIntegerColumn[] newInstances(ReadableMatrix&lt;BigInteger&gt; matrix, int booleanSize) {<a name="line.308"></a>
<FONT color="green">309</FONT>                            final int rows = matrix.getRowCount();<a name="line.309"></a>
<FONT color="green">310</FONT>                            final int cols = matrix.getColumnCount();<a name="line.310"></a>
<FONT color="green">311</FONT>                            final RawBigIntegerColumn[] res = new RawBigIntegerColumn[cols];<a name="line.311"></a>
<FONT color="green">312</FONT>                            for (int col = 0; col &lt; cols; col++) {<a name="line.312"></a>
<FONT color="green">313</FONT>                                    final BigInteger[] vals = new BigInteger[rows];                         <a name="line.313"></a>
<FONT color="green">314</FONT>                                    for (int row = 0; row &lt; rows; row++) {<a name="line.314"></a>
<FONT color="green">315</FONT>                        vals[row] = matrix.getNumberValueAt(row, col); <a name="line.315"></a>
<FONT color="green">316</FONT>                                    }<a name="line.316"></a>
<FONT color="green">317</FONT>                    res[col] = new RawBigIntegerColumn(booleanSize, vals.length, BitSetUtil.factory().create(rows), fromBigIntegers(vals));<a name="line.317"></a>
<FONT color="green">318</FONT>                            }<a name="line.318"></a>
<FONT color="green">319</FONT>                            return res;<a name="line.319"></a>
<FONT color="green">320</FONT>                    }<a name="line.320"></a>
<FONT color="green">321</FONT>                    public RawBigIntegerColumn readFrom(DataInput dataIn, int booleanSize, int numericSize) throws IOException {<a name="line.321"></a>
<FONT color="green">322</FONT>                            final IBitSet bitSet = readBinaryFrom(dataIn, booleanSize);<a name="line.322"></a>
<FONT color="green">323</FONT>                            <a name="line.323"></a>
<FONT color="green">324</FONT>                            //read numeric<a name="line.324"></a>
<FONT color="green">325</FONT>                            final int byteLen = dataIn.readInt();<a name="line.325"></a>
<FONT color="green">326</FONT>                            final byte[] bytes = new byte[byteLen];<a name="line.326"></a>
<FONT color="green">327</FONT>                            dataIn.readFully(bytes);<a name="line.327"></a>
<FONT color="green">328</FONT>                            <a name="line.328"></a>
<FONT color="green">329</FONT>                            return new RawBigIntegerColumn(booleanSize, numericSize, bitSet, bytes);<a name="line.329"></a>
<FONT color="green">330</FONT>                    }<a name="line.330"></a>
<FONT color="green">331</FONT>                    public void writeTo(RawBigIntegerColumn column, DataOutput dataOut) throws IOException {<a name="line.331"></a>
<FONT color="green">332</FONT>                            writeBinaryTo(column, dataOut);<a name="line.332"></a>
<FONT color="green">333</FONT>                            dataOut.writeInt(column.mNumericBytes.length);<a name="line.333"></a>
<FONT color="green">334</FONT>                            dataOut.write(column.mNumericBytes);<a name="line.334"></a>
<FONT color="green">335</FONT>                    }<a name="line.335"></a>
<FONT color="green">336</FONT>                    public EntityMarshaller&lt;RawBigIntegerColumn&gt; getEntityMarshaller(final int booleanSize, final int numericSize) throws IOException {<a name="line.336"></a>
<FONT color="green">337</FONT>                            return new EntityMarshaller&lt;RawBigIntegerColumn&gt;() {<a name="line.337"></a>
<FONT color="green">338</FONT>                    public RawBigIntegerColumn readFrom(DataInput in) throws IOException {<a name="line.338"></a>
<FONT color="green">339</FONT>                        return HOME.readFrom(in, booleanSize, numericSize);<a name="line.339"></a>
<FONT color="green">340</FONT>                    }<a name="line.340"></a>
<FONT color="green">341</FONT>                    public void writeTo(RawBigIntegerColumn entity, DataOutput out) throws IOException {<a name="line.341"></a>
<FONT color="green">342</FONT>                        HOME.writeTo(entity, out);<a name="line.342"></a>
<FONT color="green">343</FONT>                    }<a name="line.343"></a>
<FONT color="green">344</FONT>                };<a name="line.344"></a>
<FONT color="green">345</FONT>                    }<a name="line.345"></a>
<FONT color="green">346</FONT>            public ConcurrentTable&lt;RawBigIntegerColumn&gt; createTable(File folder, String fileName, final int booleanSize, final int numericSize) throws IOException {<a name="line.346"></a>
<FONT color="green">347</FONT>                final int boolByteLen               = BitSetUtil.byteSize(booleanSize);<a name="line.347"></a>
<FONT color="green">348</FONT>                final int numericByteLen    = numericSize * (4 + 8);//4 for len value, 8 for one long value<a name="line.348"></a>
<FONT color="green">349</FONT>                return new ConcurrentTable&lt;RawBigIntegerColumn&gt;(<a name="line.349"></a>
<FONT color="green">350</FONT>                    VariableWidthTable.create(<a name="line.350"></a>
<FONT color="green">351</FONT>                            folder, fileName, boolByteLen + numericByteLen, <a name="line.351"></a>
<FONT color="green">352</FONT>                            getEntityMarshaller(booleanSize, numericSize),<a name="line.352"></a>
<FONT color="green">353</FONT>                        Cache.BigIntegerMemoryTable.getCacheTableSize(),<a name="line.353"></a>
<FONT color="green">354</FONT>                        Cache.BigIntegerMemoryTable.getCacheEntrySize()<a name="line.354"></a>
<FONT color="green">355</FONT>                    )<a name="line.355"></a>
<FONT color="green">356</FONT>                );<a name="line.356"></a>
<FONT color="green">357</FONT>            }<a name="line.357"></a>
<FONT color="green">358</FONT>            public ConcurrentTable&lt;RawBigIntegerColumn&gt; openTable(File folder, String fileName, final int booleanSize, final int numericSize) throws IOException {<a name="line.358"></a>
<FONT color="green">359</FONT>                return new ConcurrentTable&lt;RawBigIntegerColumn&gt;(<a name="line.359"></a>
<FONT color="green">360</FONT>                    VariableWidthTable.open(<a name="line.360"></a>
<FONT color="green">361</FONT>                            folder, fileName, <a name="line.361"></a>
<FONT color="green">362</FONT>                            getEntityMarshaller(booleanSize, numericSize),<a name="line.362"></a>
<FONT color="green">363</FONT>                        Cache.BigIntegerMemoryTable.getCacheTableSize(),<a name="line.363"></a>
<FONT color="green">364</FONT>                        Cache.BigIntegerMemoryTable.getCacheEntrySize()<a name="line.364"></a>
<FONT color="green">365</FONT>                    )<a name="line.365"></a>
<FONT color="green">366</FONT>                );<a name="line.366"></a>
<FONT color="green">367</FONT>            }<a name="line.367"></a>
<FONT color="green">368</FONT>                    public FluxDistribution createFluxDistribution(MetabolicNetwork net, BigInteger[] values) {<a name="line.368"></a>
<FONT color="green">369</FONT>                            return new FractionNumberFluxDistribution(net, values);<a name="line.369"></a>
<FONT color="green">370</FONT>                    }<a name="line.370"></a>
<FONT color="green">371</FONT>                    public ReadableMatrix&lt;BigInteger&gt; convertMatrix(ReadableMatrix matrix, boolean allowRowScaling, boolean allowColumnScaling) {<a name="line.371"></a>
<FONT color="green">372</FONT>                            if (matrix instanceof ReadableBigIntegerMatrix) {<a name="line.372"></a>
<FONT color="green">373</FONT>                                    return ((ReadableBigIntegerMatrix)matrix).toBigIntegerMatrix(false /*enforceNewInstance*/);<a name="line.373"></a>
<FONT color="green">374</FONT>                            }<a name="line.374"></a>
<FONT color="green">375</FONT>                            final int rows = matrix.getRowCount();<a name="line.375"></a>
<FONT color="green">376</FONT>                            final int cols = matrix.getColumnCount();<a name="line.376"></a>
<FONT color="green">377</FONT>                            final DefaultBigIntegerMatrix mx = new DefaultBigIntegerMatrix(rows, cols);<a name="line.377"></a>
<FONT color="green">378</FONT>                            if (allowRowScaling) {<a name="line.378"></a>
<FONT color="green">379</FONT>                                    for (int row = 0; row &lt; rows; row++) {<a name="line.379"></a>
<FONT color="green">380</FONT>                                            BigInteger lcm = BigInteger.ONE;<a name="line.380"></a>
<FONT color="green">381</FONT>                                            for (int col = 0; col &lt; cols; col++) {<a name="line.381"></a>
<FONT color="green">382</FONT>                                                    final BigFraction val = BigFraction.valueOf(matrix.getNumberValueAt(row, col));<a name="line.382"></a>
<FONT color="green">383</FONT>                                                    lcm = BigIntegerUtil.lcm(lcm, val.getDenominator());<a name="line.383"></a>
<FONT color="green">384</FONT>                                            }<a name="line.384"></a>
<FONT color="green">385</FONT>                                            final BigFraction scale = BigFraction.valueOf(lcm.abs());<a name="line.385"></a>
<FONT color="green">386</FONT>                                            for (int col = 0; col &lt; cols; col++) {<a name="line.386"></a>
<FONT color="green">387</FONT>                                                    final BigFraction val = BigFraction.valueOf(matrix.getNumberValueAt(row, col));<a name="line.387"></a>
<FONT color="green">388</FONT>                                                    final BigFraction scaled = val.multiply(scale).reduce();<a name="line.388"></a>
<FONT color="green">389</FONT>                                                    if (!scaled.isInteger()) {<a name="line.389"></a>
<FONT color="green">390</FONT>                                                            throw new RuntimeException("internal error: could not scale to integer: " + scaled);<a name="line.390"></a>
<FONT color="green">391</FONT>                                                    }<a name="line.391"></a>
<FONT color="green">392</FONT>                                                    mx.setValueAt(row, col, scaled.toBigInteger());<a name="line.392"></a>
<FONT color="green">393</FONT>                                            }<a name="line.393"></a>
<FONT color="green">394</FONT>                                    }<a name="line.394"></a>
<FONT color="green">395</FONT>                            }<a name="line.395"></a>
<FONT color="green">396</FONT>                            else if (allowColumnScaling) {<a name="line.396"></a>
<FONT color="green">397</FONT>                                    for (int col = 0; col &lt; cols; col++) {<a name="line.397"></a>
<FONT color="green">398</FONT>                                            BigInteger lcm = BigInteger.ONE;<a name="line.398"></a>
<FONT color="green">399</FONT>                                            for (int row = 0; row &lt; rows; row++) {<a name="line.399"></a>
<FONT color="green">400</FONT>                                                    final BigFraction val = BigFraction.valueOf(matrix.getNumberValueAt(row, col));<a name="line.400"></a>
<FONT color="green">401</FONT>                                                    lcm = BigIntegerUtil.lcm(lcm, val.getDenominator());<a name="line.401"></a>
<FONT color="green">402</FONT>                                            }<a name="line.402"></a>
<FONT color="green">403</FONT>                                            final BigFraction scale = BigFraction.valueOf(lcm.abs());<a name="line.403"></a>
<FONT color="green">404</FONT>                                            for (int row = 0; row &lt; rows; row++) {<a name="line.404"></a>
<FONT color="green">405</FONT>                                                    final BigFraction val = BigFraction.valueOf(matrix.getNumberValueAt(row, col));<a name="line.405"></a>
<FONT color="green">406</FONT>                                                    final BigFraction scaled = val.multiply(scale).reduce();<a name="line.406"></a>
<FONT color="green">407</FONT>                                                    if (!scaled.isInteger()) {<a name="line.407"></a>
<FONT color="green">408</FONT>                                                            throw new RuntimeException("internal error: could not scale to integer: " + scaled);<a name="line.408"></a>
<FONT color="green">409</FONT>                                                    }<a name="line.409"></a>
<FONT color="green">410</FONT>                                                    mx.setValueAt(row, col, scaled.toBigInteger());<a name="line.410"></a>
<FONT color="green">411</FONT>                                            }<a name="line.411"></a>
<FONT color="green">412</FONT>                                    }<a name="line.412"></a>
<FONT color="green">413</FONT>                            }<a name="line.413"></a>
<FONT color="green">414</FONT>                            else {<a name="line.414"></a>
<FONT color="green">415</FONT>                                    throw new IllegalArgumentException("either allowRowScaling or allowColumnScaling must be true");<a name="line.415"></a>
<FONT color="green">416</FONT>                            }<a name="line.416"></a>
<FONT color="green">417</FONT>                            return mx;<a name="line.417"></a>
<FONT color="green">418</FONT>                    }<a name="line.418"></a>
<FONT color="green">419</FONT>                    public ReadableMatrix&lt;BigInteger&gt; castMatrix(ReadableMatrix matrix) {<a name="line.419"></a>
<FONT color="green">420</FONT>                            if (matrix instanceof ReadableBigIntegerMatrix) {<a name="line.420"></a>
<FONT color="green">421</FONT>                                    return ((ReadableBigIntegerMatrix)matrix).toBigIntegerMatrix(false /*enforceNewInstance*/);<a name="line.421"></a>
<FONT color="green">422</FONT>                            }<a name="line.422"></a>
<FONT color="green">423</FONT>                            throw new ClassCastException("not a ReadableBigIntegerMatrix: " + matrix.getClass().getName());<a name="line.423"></a>
<FONT color="green">424</FONT>    //                      final int rows = matrix.getRowCount();<a name="line.424"></a>
<FONT color="green">425</FONT>    //                      final int cols = matrix.getColumnCount();<a name="line.425"></a>
<FONT color="green">426</FONT>    //                      DefaultBigIntegerRationalMatrix mx = new DefaultBigIntegerRationalMatrix(rows, cols);<a name="line.426"></a>
<FONT color="green">427</FONT>    //                      for (int row = 0; row &lt; rows; row++) {<a name="line.427"></a>
<FONT color="green">428</FONT>    //                              for (int col = 0; col &lt; cols; col++) {<a name="line.428"></a>
<FONT color="green">429</FONT>    //                                      mx.setValueAt(row, col, BigInteger.valueOf(matrix.getNumberValueAt(row, col)));<a name="line.429"></a>
<FONT color="green">430</FONT>    //                              }<a name="line.430"></a>
<FONT color="green">431</FONT>    //                      }<a name="line.431"></a>
<FONT color="green">432</FONT>    //                      return mx;<a name="line.432"></a>
<FONT color="green">433</FONT>                    }<a name="line.433"></a>
<FONT color="green">434</FONT>                    public RawBigIntegerColumn castColumn(Column column) {<a name="line.434"></a>
<FONT color="green">435</FONT>                            return (RawBigIntegerColumn)column;<a name="line.435"></a>
<FONT color="green">436</FONT>                    }<a name="line.436"></a>
<FONT color="green">437</FONT>                    public BigInteger castNumber(Number number) {<a name="line.437"></a>
<FONT color="green">438</FONT>                            return (BigInteger)number;<a name="line.438"></a>
<FONT color="green">439</FONT>                    }<a name="line.439"></a>
<FONT color="green">440</FONT>                    public int rank(ReadableMatrix matrix, Zero zero) {<a name="line.440"></a>
<FONT color="green">441</FONT>                            return new Gauss(zero.mZeroPos).rank((ReadableBigIntegerRationalMatrix)matrix);<a name="line.441"></a>
<FONT color="green">442</FONT>                    }               <a name="line.442"></a>
<FONT color="green">443</FONT>            };<a name="line.443"></a>
<FONT color="green">444</FONT>        <a name="line.444"></a>
<FONT color="green">445</FONT>    }<a name="line.445"></a>




























































</PRE>
</BODY>
</HTML>
